## libktoblzcheck 1.53

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(ktoblzcheck VERSION 1.53.0)

# define path for local cmake modules
list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

########### options ###############
option(ENABLE_BANKDATA_DOWNLOAD "Enable download of raw bank data file" ON)
option(INSTALL_RAW_BANKDATA_FILE "Install raw bank data file" OFF)

########### global settings ###############
set(BANK_WEBSITE_HOST https://www.bundesbank.de)
set(BANK_WEBSITE_PATH /de/aufgaben/unbarer-zahlungsverkehr/serviceangebot/bankleitzahlen/download---bankleitzahlen-602592)
# format description
#https://www.bundesbank.de/resource/blob/602848/50cba8afda2b0b1442016101cfd7e084/mL/merkblatt-bankleitzahlendatei-data.pdf

option(INSTALL_SEPA_BANKDATA_FILE "Install sepa provider data file in csv format" OFF)
option(BUILD_STATIC "build static library and executables" OFF)
if(BUILD_STATIC)
    set(LIBS -static -static-libgcc -static-libstdc++)
    set(CMAKE_BUILD_TYPE Release)
endif()

# provide gnu compatible install dirs
include(GNUInstallDirs)

# definitions for running cross compile applications
include(MacrosWine)

# common macros
include(Macros)

# set PACKAGE_... variables
include(MacrosAutotools)
autopackage(${PROJECT_NAME} ${PROJECT_VERSION} "${PROJECT_HOMEPAGE_URL}" "https://sourceforge.net/projects/ktoblzcheck/support")

# definitions in source file
set(KTOBLZCHECK_VERSION_MAJOR ${PROJECT_VERSION_MAJOR})
set(KTOBLZCHECK_VERSION_MINOR ${PROJECT_VERSION_MINOR})
set(KTOBLZCHECK_VERSION_PATCH ${PROJECT_VERSION_PATCH})

# shared library version numbers
set(LIBKTOBLZCHECK_CURRENT 6)
set(LIBKTOBLZCHECK_AGE 5)
set(LIBKTOBLZCHECK_REVISION 26)
math(EXPR LIBKTOBLZCHECK_EFFECTIVE "${LIBKTOBLZCHECK_CURRENT} - ${LIBKTOBLZCHECK_AGE}")

if(WIN32)
    set(OS_WIN32 1)
endif()

# target build dir defaults
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
if(WIN32)
   set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
   set(CUSTOM_INSTALL_LIBDIR ${CMAKE_INSTALL_BINDIR})
else()
   set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
   set(CUSTOM_INSTALL_LIBDIR ${CMAKE_INSTALL_LIBDIR})
endif()

# target install defaults
set(INSTALL_TARGETS_DEFAULT_ARGS
    EXPORT KtoBlzCheckTargets
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

# for embedding into installed header files
set(VERSION_MAJOR ${KTOBLZCHECK_VERSION_MAJOR})
set(VERSION_MINOR ${KTOBLZCHECK_VERSION_MINOR})

########### external packages ###############
find_package(Doxygen "1.8.3")

set(CMAKE_THREAD_PREFER_PTHREAD 1)
find_package(Threads REQUIRED)
if(CMAKE_USE_PTHREADS_INIT)
    set(HAVE_LIBPTHREAD 1)
endif()

find_package (Python3 COMPONENTS Interpreter Development)
if(Python3_FOUND)
    set(Python_EXECUTABLE ${Python3_EXECUTABLE})
    string(REGEX REPLACE "^([0-9]+.[0-9]+).*" "\\1" Python_VERSION_MAJOR_MINOR ${Python3_VERSION})
    set(Python_SITEARCH "${CMAKE_INSTALL_LIBDIR}/python${Python_VERSION_MAJOR_MINOR}/site-packages")
    set(Python_Interpreter_FOUND TRUE)
    set(Python_Development_FOUND TRUE)
else()
    find_package(Python2 COMPONENTS Interpreter Development)
    # for cmake < 3.12
    if(Python2_Interpreter_FOUND)
        set(Python_EXECUTABLE ${Python2_EXECUTABLE})
        set(Python_Interpreter_FOUND TRUE)
    else()
        find_package(PythonInterp 2.7 REQUIRED)
        set(Python_Interpreter_FOUND TRUE)
        set(Python_EXECUTABLE ${PYTHON_EXECUTABLE})
    endif()
    if(Python2_Development_FOUND)
        string(REGEX REPLACE "^([0-9]+.[0-9]+).*" "\\1" Python_VERSION_MAJOR_MINOR ${Python2_VERSION})
        set(Python_SITEARCH "${CMAKE_INSTALL_LIBDIR}/python${Python_VERSION_MAJOR_MINOR}/site-packages")
        set(Python_Development_FOUND TRUE)
    else()
        find_package(PythonLibs 2.6 REQUIRED)
        set(Python_Development_FOUND TRUE)
        set(Python2_VERSION ${PYTHONLIBS_VERSION_STRING})
        string(REGEX REPLACE "^([0-9]+.[0-9]+).*" "\\1" Python_VERSION_MAJOR_MINOR ${Python2_VERSION})
        set(Python_SITEARCH "${CMAKE_INSTALL_LIBDIR}/python${Python_VERSION_MAJOR_MINOR}/site-packages")
    endif()
endif()
########### configure checks ###############
include(CheckIncludeFile)
check_include_file(dirent.h     HAVE_DIRENT_H)
check_include_file(dlfcn.h      HAVE_DLFCN_H)
check_include_file(inttypes.h   HAVE_INTTYPES_H)
check_include_file(memory.h     HAVE_MEMORY_H)
check_include_file(stdint.h     HAVE_STDINT_H)
check_include_file(stdlib.h     HAVE_STDLIB_H)
check_include_file(stdio.h      HAVE_STDIO_H)
check_include_file(string.h     HAVE_STRING_H)
check_include_file(strings.h    HAVE_STRINGS_H)
check_include_file(syslog.h     HAVE_SYSLOG_H)
check_include_file(sys/stat.h   HAVE_SYS_STAT_H)
check_include_file(sys/types.h  HAVE_SYS_TYPES_H)
check_include_file(windows.h    HAVE_WINDOWS_H)

include(CheckTypeSize)
check_type_size("long long" LONG_LONG)


# bankdata related variables
set(BANKDATA_SRCPATH ${CMAKE_SOURCE_DIR}/src/bankdata)
if(ENABLE_BANKDATA_DOWNLOAD)
    string(TIMESTAMP _BANKDATA_FILE "bankdata_%Y%m%d.txt")
    set(BANKDATA_FILE ${_BANKDATA_FILE})
    set(BANKDATA_FILEPATH "${BANKDATA_SRCPATH}/${BANKDATA_FILE}")
    message(STATUS "Using bank data file ${BANKDATA_FILEPATH}")

    string(TIMESTAMP _BANKDATA_RAW_FILE "blz_%Y%m%d.txt")
    set(BANKDATA_RAW_FILE ${_BANKDATA_RAW_FILE})
    set(BANKDATA_RAW_FILEPATH "${BANKDATA_SRCPATH}/${BANKDATA_RAW_FILE}")
    message(STATUS "Using raw bank data file ${BANKDATA_RAW_FILEPATH}")
else()
    file(GLOB BANKDATA_FILEPATH  "${BANKDATA_SRCPATH}/bankdata_*.txt")
    get_filename_component(BANKDATA_FILE ${BANKDATA_FILEPATH} NAME)
    message(STATUS "Using present bank data file ${BANKDATA_FILEPATH}")

    file(GLOB BANKDATA_RAW_FILEPATH  "${BANKDATA_SRCPATH}/blz_*.txt")
    get_filename_component(BANKDATA_RAW_FILE ${BANKDATA_RAW_FILEPATH} NAME)
    message(STATUS "Using present raw bank data file ${BANKDATA_RAW_FILEPATH}")
endif()
set(BANKDATA_PATH ${CMAKE_INSTALL_FULL_DATADIR}/ktoblzcheck)
add_definitions(-DBANKDATA_PATH="${BANKDATA_PATH}")

########### generate pkgconfig file ###############
set(prefix "\${pcfiledir}/../..")
set(exec_prefix "\${prefix}")
set(bindir "\${prefix}/${CMAKE_INSTALL_BINDIR}")
set(libdir "\${prefix}/${CMAKE_INSTALL_LIBDIR}")
set(includedir "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
set(datadir "\${prefix}/${CMAKE_INSTALL_DATADIR}")
if (Python_SITEARCH)
    set(pythondir "\${prefix}${Python_SITEARCH}")
endif()

configure_file(${PACKAGE}.pc.in ${CMAKE_CURRENT_BINARY_DIR}/${PACKAGE}.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PACKAGE}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

########### generate cmake find_package file ###############
include(CMakePackageConfigHelpers)

set(INSTALL_CMAKE_DIR ${CMAKE_INSTALL_LIBDIR}/cmake/KtoBlzCheck)
configure_package_config_file(KtoBlzCheckConfig.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/KtoBlzCheckConfig.cmake
    INSTALL_DESTINATION ${INSTALL_CMAKE_DIR}
)
write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/KtoBlzCheckConfigVersion.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY AnyNewerVersion
)

install(EXPORT KtoBlzCheckTargets
    FILE KtoBlzCheckTargets.cmake
    DESTINATION ${INSTALL_CMAKE_DIR}
)

# used by install autotests
export(EXPORT KtoBlzCheckTargets FILE KtoBlzCheckTargets.cmake)

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/KtoBlzCheckConfig.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/KtoBlzCheckConfigVersion.cmake
    DESTINATION ${INSTALL_CMAKE_DIR}
)

########### generate config.h ###############
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)
add_definitions(
    -DHAVE_CONFIG_H
)

########### generate spec file ###############
configure_file(ktoblzcheck.spec.in ${CMAKE_BINARY_DIR}/ktoblzcheck.spec)

########### generate tarball ###############
set(tarname ${PACKAGE}-${PROJECT_VERSION})
set(temppath ${CMAKE_BINARY_DIR}/tmp/${tarname})
set(tarball ${CMAKE_BINARY_DIR}/${tarname}.tar.gz)
add_custom_command(OUTPUT ${temppath}
    COMMAND ${CMAKE_COMMAND} -E make_directory ${temppath}
)

add_custom_target(dist
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_SOURCE_DIR}  ${temppath}
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_BINARY_DIR}/config.h.cmake ${temppath}
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_BINARY_DIR}/ktoblzcheck.spec ${temppath}
    COMMAND ${CMAKE_COMMAND} -E tar -czf ${tarball} ${tarname}
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/tmp
    COMMENT "generating ${tarball}"
    DEPENDS ${temppath} ${CMAKE_BINARY_DIR}/ktoblzcheck.spec ${CMAKE_BINARY_DIR}/config.h.cmake
)

add_custom_target(rpm
    COMMAND rpmbuild -ta ${tarball}
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    COMMENT "generating rpm file"
    DEPENDS dist
)

add_custom_target(srpm
    COMMAND rpmbuild -ts ${tarball}
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    COMMENT "generating srpm file"
    DEPENDS dist
)

#
# add package_source target
#

# find files not in git repo
exec_program(git ${CMAKE_SOURCE_DIR}
    ARGS ls-files --others --directory
    OUTPUT_VARIABLE IGNORE_FILES
)
string(REGEX REPLACE "\n" ";" IGNORE_FILES "${IGNORE_FILES}")

# did not find a way to disable binary generator for now
set(CPACK_GENERATOR "XX")
set(CPACK_STRIP_FILES TRUE)
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_IGNORE_FILES ".git;${IGNORE_FILES}")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "${PROJECT_NAME}-${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}")
include(CPack)

########### generate installer ###############
if(WIN32)
    find_file(
        ISCC_EXECUTABLE ISCC.exe
        PATH
            ${ISCC_DIR}
            "$ENV{ProgramFiles}/Inno\ Setup\ 5/"
            "$ENV{ProgramFiles}/Inno\ Setup\ 6/"
        NO_DEFAULT_PATH
    )
    if (ISCC_EXECUTABLE)
        message(STATUS "Inno Setup compiler found at ${ISCC_EXECUTABLE}")
        configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ktoblzcheck.iss.in ${CMAKE_CURRENT_BINARY_DIR}/ktoblzcheck.iss)
        set(FILES "README;COPYING;README.WIN32;AUTHORS;ChangeLog")
        foreach(f ${FILES})
            configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${f} ${CMAKE_CURRENT_BINARY_DIR}/${f} COPYONLY)
        endforeach()
        add_custom_target(setup
            COMMAND ${CMAKE_MAKE_PROGRAM} install DESTDIR=${CMAKE_CURRENT_BINARY_DIR}/win32-tmp
            COMMAND ${CMAKE_COMMAND} -E copy_directory
                ${CMAKE_CURRENT_BINARY_DIR}/win32-tmp${CMAKE_INSTALL_PREFIX}
                ${CMAKE_CURRENT_BINARY_DIR}/win32-tmp
            COMMAND wine ${ISCC_EXECUTABLE} z:${CMAKE_CURRENT_BINARY_DIR}/ktoblzcheck.iss
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        )
    endif()
endif()

# enable ctest
enable_testing()

add_subdirectory(autotests)
add_subdirectory(src)
add_subdirectory(doc)


add_custom_target(uncrustify
    COMMAND ${CMAKE_SOURCE_DIR}/uncrustify.sh
    COMMENT "uncrustify sources"
)

include(FeatureSummary)
feature_summary(WHAT ALL)

=== autotests/CMakeLists.txt ===
add_test(install ${CMAKE_CTEST_COMMAND}
    --build-and-test
    "${CMAKE_CURRENT_SOURCE_DIR}/install"
    "${CMAKE_CURRENT_BINARY_DIR}/install"
    --build-generator ${CMAKE_GENERATOR}
    --build-makeprogram ${CMAKE_MAKE_PROGRAM}
    --build-target install
    --build-options
        "-DCMAKE_MODULE_PATH=${CMAKE_MODULE_PATH}"
        "-DCMAKE_INSTALL_PREFIX:PATH=${CMAKE_CURRENT_BINARY_DIR}/install/destdir"
        "-DKtoBlzCheck_DIR=${CMAKE_BINARY_DIR}"
        "-DCHECK_VERSION=${PROJECT_VERSION}"
)

=== doc/CMakeLists.txt ===

# build doc always
add_custom_target(doc ALL)

if(DOXYGEN_EXECUTABLE)
    set(ENABLE_DOXYGEN_DOCS 1)
endif()

if(ENABLE_DOXYGEN_DOCS)
    set (top_srcdir ${CMAKE_SOURCE_DIR})
    configure_file(../Doxyfile.in ${CMAKE_BINARY_DIR}/Doxyfile )
    add_custom_command(
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/api/html/index.html
        COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )
    add_custom_target(apidoc
        DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/api/html/index.html
    )
    add_dependencies(doc apidoc)
    install(DIRECTORY ${CMAKE_BINARY_DIR}/apidoc/html/ DESTINATION ${CMAKE_INSTALL_DATADIR}/doc/ktoblzcheck/api)
endif()

install(FILES ibanchk.1 ktoblzcheck.1 DESTINATION ${CMAKE_INSTALL_DATADIR}/man/man1)

=== src/CMakeLists.txt ===

include_directories(
    include
    ${CMAKE_BINARY_DIR}
    ${CMAKE_BINARY_DIR}/src/include
)

add_subdirectory(bankdata)
add_subdirectory(include)
add_subdirectory(lib)
add_subdirectory(bin)
if(Python_Development_FOUND)
    add_subdirectory(python)
endif()

=== src/bankdata/CMakeLists.txt ===
set(BANK_WEBSITE_URL ${BANK_WEBSITE_HOST}${BANK_WEBSITE_PATH})

set(TEMP_FILE "${CMAKE_CURRENT_BINARY_DIR}/tmpfile.txt")
set(SEARCH_FILENAME blz-aktuell-txt-data.txt)

# generate cmake script for downloading bank data file
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/tmp.cmake "
    file(DOWNLOAD \"${BANK_WEBSITE_URL}\" \"${TEMP_FILE}\")
    file(READ \"${TEMP_FILE}\" DATA)
    #message(\"\${DATA}\")
    string(REGEX REPLACE \".*href=\\\"(.*/${SEARCH_FILENAME})\\\".*\" \"${BANK_WEBSITE_HOST}/\\\\1\" FILE_URL  \"\${DATA}\")
    message(\"got file url \${FILE_URL}\")
    file(DOWNLOAD \"\${FILE_URL}\" \"${BANKDATA_RAW_FILEPATH}\")
")

# fetch raw bankdata file
add_custom_command(
    OUTPUT ${BANKDATA_RAW_FILEPATH}
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/tmp.cmake
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Download raw bank data file to ${BANKDATA_RAW_FILEPATH}"
)

# convert into ktoblzcheck format
add_custom_command(
    OUTPUT ${BANKDATA_FILEPATH}
    COMMAND ${Python_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/bankdata.py -o ${BANKDATA_FILEPATH} ${BANKDATA_RAW_FILEPATH}
    DEPENDS ${BANKDATA_RAW_FILEPATH}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
)

add_custom_target(fetch_bankdata
    DEPENDS ${BANKDATA_RAW_FILENAME}
)

add_custom_target(bankdata_de
    DEPENDS ${BANKDATA_FILEPATH}
)

add_subdirectory(sepa)

set(INSTALL_FILES
    ${BANKDATA_FILEPATH}
    ibandata.txt
)

if(INSTALL_RAW_BANKDATA_FILE)
    list(APPEND INSTALL_FILES ${BANKDATA_RAW_FILEPATH})
endif()

install(FILES ${INSTALL_FILES} DESTINATION share/${PROJECT_NAME})

=== src/bin/CMakeLists.txt ===

########### next target ###############

set(ktoblzcheck_bin_SRCS ktoblzcheck.cc)
add_executable(ktoblzcheck-bin ${ktoblzcheck_bin_SRCS})
target_link_libraries(ktoblzcheck-bin ktoblzcheck)
set_target_properties(ktoblzcheck-bin PROPERTIES OUTPUT_NAME ktoblzcheck)
if(BUILD_STATIC)
    # strip executables
    set(CMAKE_EXE_LINKER_FLAGS_RELEASE -s)
endif()

install(TARGETS ktoblzcheck-bin DESTINATION bin)

add_test(
    NAME ktoblzcheck
    COMMAND ${TEST_WRAPPER} $<TARGET_FILE:ktoblzcheck-bin> --file=${TEST_PATH_PREFIX}${BANKDATA_FILEPATH} 20050550 1262693334
)

## This check should return 1. If not, error
#add_test(
#    NAME ktoblzcheck_invalid
#    COMMAND $<TARGET_FILE:ktoblzcheck-bin> --file=${BANKDATA_LOCAL_FILEPATH} 20050550 1262693333
#)

set(ctest_SRCS ctest.c)
add_executable(ctest ${ctest_SRCS})

########### next target ###############

set(benchmark_SRCS benchmark.cc)
add_executable(benchmark ${benchmark_SRCS})
target_link_libraries(benchmark ktoblzcheck)

add_test(
    NAME benchmark
    COMMAND ${TEST_WRAPPER} $<TARGET_FILE:benchmark> 5 ${TEST_PATH_PREFIX}${BANKDATA_FILEPATH}
)

########### next target ###############

#
# TODO:  seems to be redundant (see lib)
#
set(ibanchk_SRCS ibanchk.cc)
add_executable(ibanchk ${ibanchk_SRCS})
target_link_libraries(ibanchk ktoblzcheck)

install(TARGETS ibanchk DESTINATION bin)

# not working yet because of different return code
#add_test(
#    NAME ibanchk_invalid
#    COMMAND $<TARGET_FILE:ibanchk> "FR1420041010050500013X02606"
#)

add_test(
    NAME ibanchk_de
    COMMAND ${TEST_WRAPPER} $<TARGET_FILE:ibanchk> "DE89 3704 0044 0532 0130 00"
)
set_tests_properties(ibanchk_de PROPERTIES
    ENVIRONMENT XDG_DATA_DIRS=${TEST_PATH_PREFIX}${CMAKE_SOURCE_DIR}/src/bankdata
)

add_test(
    NAME ibanchk_fr
    COMMAND ${TEST_WRAPPER} $<TARGET_FILE:ibanchk> "fr14 2004 1010 0505 0001 3m02 606"
)
set_tests_properties(ibanchk_fr PROPERTIES
    ENVIRONMENT XDG_DATA_DIRS=${TEST_PATH_PREFIX}${CMAKE_SOURCE_DIR}/src/bankdata
)

=== src/include/CMakeLists.txt ===

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ktoblzcheck.h.in ${CMAKE_CURRENT_BINARY_DIR}/ktoblzcheck.h)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/ktoblzcheck.h iban.h DESTINATION include)

=== src/lib/CMakeLists.txt ===

include_directories(
    ${CMAKE_SOURCE_DIR}/src/include
    ${CMAKE_BINARY_DIR}
    ${CMAKE_BINARY_DIR}/src/include
)

########### next target ###############

set(ktoblzcheck_LIB_SRCS
    ktoblzcheck.cc
    methods.cc
    algorithms.cc
    accnum.cc
    iban.cc
)
if(BUILD_STATIC)
    set(MODE STATIC)
else()
    set(MODE SHARED)
endif()

add_library(ktoblzcheck ${MODE} ${ktoblzcheck_LIB_SRCS})
target_link_libraries(ktoblzcheck stdc++ ${LIBS})
if(WIN32)
    set_target_properties(ktoblzcheck PROPERTIES SUFFIX "-${LIBKTOBLZCHECK_EFFECTIVE}${CMAKE_SHARED_LIBRARY_SUFFIX}")
else()
    set_target_properties(ktoblzcheck PROPERTIES VERSION ${LIBKTOBLZCHECK_EFFECTIVE}.${LIBKTOBLZCHECK_AGE}.${LIBKTOBLZCHECK_REVISION} SOVERSION ${LIBKTOBLZCHECK_EFFECTIVE})
endif()

add_dependencies(ktoblzcheck bankdata_de)
add_dependencies(ktoblzcheck fetch_sepa)

install(TARGETS ktoblzcheck ${INSTALL_TARGETS_DEFAULT_ARGS})

########### next target ###############

set(iban_check_SRCS iban_check.cc)
add_executable(iban_check ${iban_check_SRCS})
target_link_libraries(iban_check ktoblzcheck)
add_test(
    NAME iban_check
    COMMAND ${TEST_WRAPPER} $<TARGET_FILE:iban_check>
)
set(env "BANKDATA_SRCPATH=${BANKDATA_SRCPATH}")
set_tests_properties(iban_check PROPERTIES ENVIRONMENT "${env}")

########### next target ###############

set(date_test_SRCS ktoblzcheck.cc)
add_executable(date_test ${date_test_SRCS})
target_link_libraries(date_test)
target_compile_definitions(date_test PUBLIC ONLY_EXTRACT_DATE_TEST=1)
add_test(
    NAME date_test
    COMMAND ${TEST_WRAPPER} $<TARGET_FILE:date_test>
)

=== src/python/CMakeLists.txt ===

install(FILES ktoblzcheck.py DESTINATION ${Python_SITEARCH})

if(Python_Interpreter_FOUND)
add_test(
    NAME test-python
    COMMAND ${Python_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/test_ktoblzcheck.py
)
set_tests_properties(test-python PROPERTIES
    ENVIRONMENT "LD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/lib;XDG_DATA_DIRS=${CMAKE_SOURCE_DIR}/src/bankdata"
)
endif()

=== src/bankdata/sepa/CMakeLists.txt ===
fetch_file(
    KEY sepa
    URL https://www.bundesbank.de/resource/blob/602880/c9e0b10e3678615c2651a61c004ba850/mL/verzeichnis-der-erreichbaren-zahlungsdienstleister-data.csv
)

if(INSTALL_SEPA_BANKDATA_FILE)
    install(FILES ${DATA_FILEPATH_sepa} DESTINATION share/${PROJECT_NAME})
endif()

=== debian/changelog ===
libktoblzcheck (1.53-2) unstable; urgency=medium

  * Bump debhelper from 12 to 13.
  * debian/clean: Delete src/python/__pycache__ too.
  * Package is compliant to Debian Policy 4.5.1 (no changes needed).

 -- Micha Lenk <micha@debian.org>  Tue, 23 Feb 2021 21:33:24 +0100

libktoblzcheck (1.53-1) unstable; urgency=medium

  * New upstream version 1.53.
  * debian/rules: Re-enable running the test-python unit tests.
  * Package is compliant to Debian Policy 4.5.0 (no changes needed).
  * libktoblzcheck1-dev: Ship cmake modules too.

 -- Micha Lenk <micha@debian.org>  Sat, 25 Apr 2020 21:37:25 +0200

libktoblzcheck (1.52-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Use secure URI in debian/watch.
  * Bump debhelper from old 11 to 12.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Archive, Name, Repository.

  [ Micha Lenk ]
  * New upstream version 1.52
  * Drop patch 0001_drop_python2_detection.patch (fixed differently upstream).
  * Drop patch fix_missing_BANKDATA_PATH.patch (the issue got fixed differently
    upstream).
  * Add build dependency on python-all-dev and dh-python to fix build failures.
  * debian/rules: Skip running the broken test-python unit tests. This
    currently prevents packaging the python modules again.

  [ Benjamin Eikel ]
  * The new upstream version now installs the ibanchk executable for checking
    international bank account numbers (IBANs) on the command line (the issue
    of this missing executable was initially reported via Debian but got
    integrated and released by upstream almost immediately).

 -- Micha Lenk <micha@debian.org>  Fri, 10 Apr 2020 23:40:13 +0200

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
export DH_VERBOSE=1

%:
	dh $@ --with python3

override_dh_auto_configure:
	dh_auto_configure -- \
		-DENABLE_BANKDATA_DOWNLOAD=0 \
		-DINSTALL_RAW_BANKDATA_FILE=1

=== debian/tests/control ===
Test-Command: ktoblzcheck 10000000 1
Depends: @

=== debian/watch ===
version=3
https://sf.net/ktoblzcheck/ \
  ktoblzcheck-([\d.]*).tar.gz debian uupdate

## libktoblzcheck 1.57

=== src/lib/CMakeLists.txt ===
--- 
+++ 
@@ -13,6 +13,7 @@
     algorithms.cc
     accnum.cc
     iban.cc
+    updater.cc
 )
 if(BUILD_STATIC)
     set(MODE STATIC)
@@ -21,7 +22,7 @@
 endif()
 
 add_library(ktoblzcheck ${MODE} ${ktoblzcheck_LIB_SRCS})
-target_link_libraries(ktoblzcheck stdc++ ${LIBS})
+target_link_libraries(ktoblzcheck PRIVATE stdc++ ${LIBS} ${SQLite3_LIBRARIES} ${CURL_LIBRARIES})
 if(WIN32)
     set_target_properties(ktoblzcheck PROPERTIES SUFFIX "-${LIBKTOBLZCHECK_EFFECTIVE}${CMAKE_SHARED_LIBRARY_SUFFIX}")
 else()
@@ -29,6 +30,10 @@
 endif()
 
 add_dependencies(ktoblzcheck bankdata_de)
+add_dependencies(ktoblzcheck bankdata_db)
+add_dependencies(ktoblzcheck bankdata_nl_db)
+add_dependencies(ktoblzcheck bankdata_ch_db)
+add_dependencies(ktoblzcheck bankdata_test_db)
 add_dependencies(ktoblzcheck fetch_sepa)
 
 install(TARGETS ktoblzcheck ${INSTALL_TARGETS_DEFAULT_ARGS})

=== debian/changelog ===
libktoblzcheck (1.57-2) experimental; urgency=medium

  * Add patch ENABLE_BANKDATA_DOWNLOAD_broken.patch to fix unexpected network
    access during build (Closes: #1084790). Thanks to Santiago Vila for all the
    help spotting the root cause.
  * Update bankdata.

 -- Micha Lenk <micha@debian.org>  Sun, 03 Nov 2024 16:03:28 +0100

libktoblzcheck (1.57-1) experimental; urgency=medium

  * New upstream version 1.57 (closes: #1074673).
  * debian/control: Add new build dependencies on python3-openpyxl,
    libcurl4-gnutls-dev and libsqlite3-dev.
  * Bundle current bankdata in debian/bankdata/.
  * Package is compliant to Debian Policy 4.7.0 (no changes needed)
  * debian/watch: Bump to format version 4 and use well-known patterns
  * debian/upstream/metadata: Add references to upstream bug tracker

 -- Micha Lenk <micha@debian.org>  Sun, 29 Sep 2024 13:16:09 +0200

libktoblzcheck (1.53-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062395

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 13:32:23 +0000

libktoblzcheck (1.53-3) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster.

  [ Micha Lenk ]
  * Fix build failure caused by Python version change (Closes: #1009421).
  * Package is compliant to Debian Policy 4.6.0 (no changes needed).

 -- Micha Lenk <micha@debian.org>  Fri, 15 Apr 2022 17:29:52 +0200

=== debian/control ===
Source: libktoblzcheck
Section: libs
Priority: optional
Maintainer: Micha Lenk <micha@debian.org>
Uploaders: Henning Glawe <glaweh@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
 dh-python,
 cmake,
 libcurl4-gnutls-dev,
 libsqlite3-dev,
 python3-all-dev,
 python3-openpyxl
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/aqbanking-team/pkg-ktoblzcheck
Vcs-Git: https://salsa.debian.org/aqbanking-team/pkg-ktoblzcheck.git

Package: libktoblzcheck1t64
Provides: ${t64:Provides}
X-Time64-Compat: libktoblzcheck1v5
Breaks: libktoblzcheck1v5 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${perl:Depends}, ${misc:Depends}
Suggests: ktoblzcheck
Conflicts: libktoblzcheck1c2a
Replaces: libktoblzcheck1v5, libktoblzcheck1c2a
Description: library for verification of account numbers and bank codes
 libktoblzcheck is a library for verification of bank account numbers and bank
 codes (BLZ) of German Banks. It is based on the specifications of the
 "Deutsche Bundesbank". It also supports the verification of international bank
 account numbers (IBAN) and bank identifier codes (BIC).

Package: libktoblzcheck1-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libktoblzcheck1t64 (= ${binary:Version}), ${misc:Depends}
Description: library for verification of account numbers and bank codes (development files)
 libktoblzcheck is a library for verification of bank account numbers and bank
 codes (BLZ) of German Banks. It is based on the specifications of the
 "Deutsche Bundesbank". It also supports the verification of international bank
 account numbers (IBAN) and bank identifier codes (BIC).
 .
 This package contains the development files.

Package: ktoblzcheck
Section: misc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, wget
Description: tool for verification of account numbers and bank codes
 ktoblzcheck is a command line tool for verification of bank account numbers
 and bank codes (BLZ) of German Banks. It is based on the specifications of the
 "Deutsche Bundesbank". It also supports the verification of international bank
 account numbers (IBAN) and bank identifier codes (BIC).

=== debian/rules ===
--- 
+++ 
@@ -7,6 +7,12 @@
 	dh $@ --with python3
 
 override_dh_auto_configure:
+	install -dv src/bankdata
+	install -v debian/bankdata/blz_2*.txt src/bankdata/
+	install -v debian/bankdata/ch_data.txt src/bankdata/
+	install -v debian/bankdata/nl_data.xlsx src/bankdata/
+	install -dv src/bankdata/sepa
+	install -v debian/bankdata/sepa/*.txt src/bankdata/sepa/
 	dh_auto_configure -- \
 		-DENABLE_BANKDATA_DOWNLOAD=0 \
 		-DINSTALL_RAW_BANKDATA_FILE=1

## libktoblzcheck 1.59

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,29 +1,25 @@
-cmake_minimum_required(VERSION 3.0)
-
-project(ktoblzcheck VERSION 1.53.0)
-
-# define path for local cmake modules
-list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
+cmake_minimum_required(VERSION 3.14.0)
+
+project(ktoblzcheck VERSION 1.59.0)
+
+# provide gnu compatible install dirs
+include(GNUInstallDirs)
 
 ########### options ###############
-option(ENABLE_BANKDATA_DOWNLOAD "Enable download of raw bank data file" ON)
-option(INSTALL_RAW_BANKDATA_FILE "Install raw bank data file" OFF)
+set(BANKDATA_PATH "${CMAKE_INSTALL_FULL_DATADIR}/ktoblzcheck" CACHE STRING "Path where bankdata files are installed")
+option(ENABLE_METHOD_TESTS "Enable testing methods" OFF)
 
 ########### global settings ###############
-set(BANK_WEBSITE_HOST https://www.bundesbank.de)
-set(BANK_WEBSITE_PATH /de/aufgaben/unbarer-zahlungsverkehr/serviceangebot/bankleitzahlen/download---bankleitzahlen-602592)
-# format description
-#https://www.bundesbank.de/resource/blob/602848/50cba8afda2b0b1442016101cfd7e084/mL/merkblatt-bankleitzahlendatei-data.pdf
-
-option(INSTALL_SEPA_BANKDATA_FILE "Install sepa provider data file in csv format" OFF)
 option(BUILD_STATIC "build static library and executables" OFF)
 if(BUILD_STATIC)
     set(LIBS -static -static-libgcc -static-libstdc++)
     set(CMAKE_BUILD_TYPE Release)
 endif()
 
-# provide gnu compatible install dirs
-include(GNUInstallDirs)
+set (CMAKE_CXX_STANDARD 14)
+
+# define path for local cmake modules
+list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
 
 # definitions for running cross compile applications
 include(MacrosWine)
@@ -82,42 +78,44 @@
     set(HAVE_LIBPTHREAD 1)
 endif()
 
-find_package (Python3 COMPONENTS Interpreter Development)
-if(Python3_FOUND)
-    set(Python_EXECUTABLE ${Python3_EXECUTABLE})
-    string(REGEX REPLACE "^([0-9]+.[0-9]+).*" "\\1" Python_VERSION_MAJOR_MINOR ${Python3_VERSION})
-    set(Python_SITEARCH "${CMAKE_INSTALL_LIBDIR}/python${Python_VERSION_MAJOR_MINOR}/site-packages")
+if(CMAKE_CROSSCOMPILING)
+    if(Python3_SITEARCH)
+        set(Python_SITEARCH ${Python3_SITEARCH])
+    endif()
+    if(Python3_EXECUTABLE)
+        set(Python_EXECUTABLE ${Python3_EXECUTABLE])
+    endif()
+    if(NOT Python_SITEARCH)
+        message(FATAL_ERROR "Could not detect python3 installation directory for site packages."
+        "To specify it, add -DPython_SITEARCH=<path> to cmake configure command.")
+    endif()
+    if(NOT Python_EXECUTABLE)
+        message(FATAL_ERROR "Could not detect python3 executable for running command on the native system"
+        "To specify it, add -DPython_EXECUTABLE=<path> to cmake configure command.")
+    endif()
     set(Python_Interpreter_FOUND TRUE)
-    set(Python_Development_FOUND TRUE)
 else()
-    find_package(Python2 COMPONENTS Interpreter Development)
-    # for cmake < 3.12
-    if(Python2_Interpreter_FOUND)
-        set(Python_EXECUTABLE ${Python2_EXECUTABLE})
+    find_package (Python3 COMPONENTS Interpreter)
+    if(Python3_FOUND)
+        set(Python_EXECUTABLE ${Python3_EXECUTABLE})
+        string(REGEX REPLACE "^([0-9]+.[0-9]+).*" "\\1" Python_VERSION_MAJOR_MINOR ${Python3_VERSION})
+        set(Python_SITEARCH "${CMAKE_INSTALL_LIBDIR}/python${Python_VERSION_MAJOR_MINOR}/site-packages")
         set(Python_Interpreter_FOUND TRUE)
-    else()
-        find_package(PythonInterp 2.7 REQUIRED)
-        set(Python_Interpreter_FOUND TRUE)
-        set(Python_EXECUTABLE ${PYTHON_EXECUTABLE})
-    endif()
-    if(Python2_Development_FOUND)
-        string(REGEX REPLACE "^([0-9]+.[0-9]+).*" "\\1" Python_VERSION_MAJOR_MINOR ${Python2_VERSION})
-        set(Python_SITEARCH "${CMAKE_INSTALL_LIBDIR}/python${Python_VERSION_MAJOR_MINOR}/site-packages")
-        set(Python_Development_FOUND TRUE)
-    else()
-        find_package(PythonLibs 2.6 REQUIRED)
-        set(Python_Development_FOUND TRUE)
-        set(Python2_VERSION ${PYTHONLIBS_VERSION_STRING})
-        string(REGEX REPLACE "^([0-9]+.[0-9]+).*" "\\1" Python_VERSION_MAJOR_MINOR ${Python2_VERSION})
-        set(Python_SITEARCH "${CMAKE_INSTALL_LIBDIR}/python${Python_VERSION_MAJOR_MINOR}/site-packages")
-    endif()
-endif()
+        message(STATUS "found python3 version ${Python3_VERSION} with site packages installation directory '${Python_SITEARCH}'")
+    endif()
+endif()
+
+find_package(SQLite3 REQUIRED)
+find_package(CURL REQUIRED)
+cmake_policy(SET CMP0079 NEW)
+
 ########### configure checks ###############
 include(CheckIncludeFile)
 check_include_file(dirent.h     HAVE_DIRENT_H)
 check_include_file(dlfcn.h      HAVE_DLFCN_H)
 check_include_file(inttypes.h   HAVE_INTTYPES_H)
 check_include_file(memory.h     HAVE_MEMORY_H)
+check_include_file(sqlite3.h    HAVE_SQLITE3_H)
 check_include_file(stdint.h     HAVE_STDINT_H)
 check_include_file(stdlib.h     HAVE_STDLIB_H)
 check_include_file(stdio.h      HAVE_STDIO_H)
@@ -132,29 +130,31 @@
 check_type_size("long long" LONG_LONG)
 
 
-# bankdata related variables
+# bankdata related variables in source dir
 set(BANKDATA_SRCPATH ${CMAKE_SOURCE_DIR}/src/bankdata)
-if(ENABLE_BANKDATA_DOWNLOAD)
-    string(TIMESTAMP _BANKDATA_FILE "bankdata_%Y%m%d.txt")
-    set(BANKDATA_FILE ${_BANKDATA_FILE})
-    set(BANKDATA_FILEPATH "${BANKDATA_SRCPATH}/${BANKDATA_FILE}")
-    message(STATUS "Using bank data file ${BANKDATA_FILEPATH}")
-
-    string(TIMESTAMP _BANKDATA_RAW_FILE "blz_%Y%m%d.txt")
-    set(BANKDATA_RAW_FILE ${_BANKDATA_RAW_FILE})
-    set(BANKDATA_RAW_FILEPATH "${BANKDATA_SRCPATH}/${BANKDATA_RAW_FILE}")
-    message(STATUS "Using raw bank data file ${BANKDATA_RAW_FILEPATH}")
-else()
-    file(GLOB BANKDATA_FILEPATH  "${BANKDATA_SRCPATH}/bankdata_*.txt")
-    get_filename_component(BANKDATA_FILE ${BANKDATA_FILEPATH} NAME)
-    message(STATUS "Using present bank data file ${BANKDATA_FILEPATH}")
-
-    file(GLOB BANKDATA_RAW_FILEPATH  "${BANKDATA_SRCPATH}/blz_*.txt")
-    get_filename_component(BANKDATA_RAW_FILE ${BANKDATA_RAW_FILEPATH} NAME)
-    message(STATUS "Using present raw bank data file ${BANKDATA_RAW_FILEPATH}")
-endif()
-set(BANKDATA_PATH ${CMAKE_INSTALL_FULL_DATADIR}/ktoblzcheck)
+set(BANKDATA_TEST_FILEPATH "${BANKDATA_SRCPATH}/bankdata_test.txt")
+
+# bankdata related variables for install location
 add_definitions(-DBANKDATA_PATH="${BANKDATA_PATH}")
+
+# bankdata database related variables
+set(BANKDATA_DB "bankdata.de.db")
+set(BANKDATA_NL_DB "bankdata.nl.db")
+set(BANKDATA_CH_DB "bankdata.ch.db")
+set(BANKDATA_TEST_DB "bankdata.test.db")
+
+set(BANKDATA_DBPATH "${BANKDATA_PATH}/${BANKDATA_DB}")
+set(BANKDATA_NL_DBPATH "${BANKDATA_PATH}/${BANKDATA_NL_DB}")
+set(BANKDATA_CH_DBPATH "${BANKDATA_PATH}/${BANKDATA_CH_DB}")
+set(BANKDATA_TEST_DBPATH "${BANKDATA_SRCPATH}/${BANKDATA_TEST_DB}")
+
+list(APPEND ADDITIONAL_CLEAN_FILES ${BANKDATA_TEST_DBPATH})
+
+message(STATUS "Using bank data db ${BANKDATA_DBPATH}")
+message(STATUS "Using bank data db ${BANKDATA_NL_DBPATH}")
+message(STATUS "Using bank data db ${BANKDATA_CH_DBPATH}")
+message(STATUS "Using bank data db ${BANKDATA_TEST_DBPATH}")
+
 
 ########### generate pkgconfig file ###############
 set(prefix "\${pcfiledir}/../..")
@@ -216,13 +216,7 @@
 )
 
 add_custom_target(dist
-    COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_SOURCE_DIR}  ${temppath}
-    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_BINARY_DIR}/config.h.cmake ${temppath}
-    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_BINARY_DIR}/ktoblzcheck.spec ${temppath}
-    COMMAND ${CMAKE_COMMAND} -E tar -czf ${tarball} ${tarname}
-    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/tmp
-    COMMENT "generating ${tarball}"
-    DEPENDS ${temppath} ${CMAKE_BINARY_DIR}/ktoblzcheck.spec ${CMAKE_BINARY_DIR}/config.h.cmake
+    COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} -t package_source
 )
 
 add_custom_target(rpm
@@ -248,14 +242,21 @@
     ARGS ls-files --others --directory
     OUTPUT_VARIABLE IGNORE_FILES
 )
+
 string(REGEX REPLACE "\n" ";" IGNORE_FILES "${IGNORE_FILES}")
 
-# did not find a way to disable binary generator for now
-set(CPACK_GENERATOR "XX")
+set(CPACK_GENERATOR "TGZ")
+set(CPACK_SOURCE_GENERATOR "TGZ")
+list(APPEND CPACK_SOURCE_IGNORE_FILES
+    .git/
+    ${IGNORE_FILES}
+    build/
+    ".*~$"
+    ".*\\.autosave"
+)
+set(CPACK_SOURCE_PACKAGE_FILE_NAME "${PROJECT_NAME}-${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}")
 set(CPACK_STRIP_FILES TRUE)
-set(CPACK_SOURCE_GENERATOR "TGZ")
-set(CPACK_SOURCE_IGNORE_FILES ".git;${IGNORE_FILES}")
-set(CPACK_SOURCE_PACKAGE_FILE_NAME "${PROJECT_NAME}-${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}")
+set(CPACK_VERBATIM_VARIABLES YES)
 include(CPack)
 
 ########### generate installer ###############
@@ -289,7 +290,9 @@
 # enable ctest
 enable_testing()
 
-add_subdirectory(autotests)
+if(NOT CROSS_COMPILING)
+    add_subdirectory(autotests)
+endif()
 add_subdirectory(src)
 add_subdirectory(doc)

=== src/CMakeLists.txt ===

include_directories(
    include
    ${CMAKE_BINARY_DIR}
    ${CMAKE_BINARY_DIR}/src/include
)

add_subdirectory(include)
add_subdirectory(lib)
add_subdirectory(bin)
if(Python_Interpreter_FOUND)
    add_subdirectory(python)
endif()

=== autotests/install/CMakeLists.txt ===
project(ktoblzcheck_install)
cmake_minimum_required(VERSION 3.14.0)

set (CMAKE_CXX_STANDARD 11)

cmake_policy(SET CMP0065 OLD)

find_package(KtoBlzCheck ${CHECK_VERSION} REQUIRED)

include_directories(${KtoBlzCheck_DIR}/src/include)

add_executable(mytest mytest.cc)
target_link_libraries(mytest ktoblzcheck)

install(TARGETS mytest RUNTIME DESTINATION bin)

=== src/bin/CMakeLists.txt ===

########### next target ###############

set(ktoblzcheck_bin_SRCS ktoblzcheck.cc)
add_executable(ktoblzcheck-bin ${ktoblzcheck_bin_SRCS})
target_link_libraries(ktoblzcheck-bin ktoblzcheck)
set_target_properties(ktoblzcheck-bin PROPERTIES OUTPUT_NAME ktoblzcheck)
if(BUILD_STATIC)
    # strip executables
    set(CMAKE_EXE_LINKER_FLAGS_RELEASE -s)
endif()

install(TARGETS ktoblzcheck-bin DESTINATION bin)

# tests for AccountNumberCheck::OK
add_test(
    NAME ktoblzcheck_de
    COMMAND ${TEST_WRAPPER} $<TARGET_FILE:ktoblzcheck-bin> --file=${BANKDATA_DBPATH} 20050550 1262693334
)

add_test(
    NAME ktoblzcheck_nl
    COMMAND ${TEST_WRAPPER} $<TARGET_FILE:ktoblzcheck-bin> --file=${BANKDATA_NL_DBPATH} ABNA 0417164300
)

add_test(
    NAME ktoblzcheck_ch
    COMMAND ${TEST_WRAPPER} $<TARGET_FILE:ktoblzcheck-bin> --file=${BANKDATA_CH_DBPATH} 00761 011623852957
)

#tests for AccountNumberCheck::ERROR
add_test(
    NAME ktoblzcheck_de_invalid1
    COMMAND $<TARGET_FILE:ktoblzcheck-bin> --file=${BANKDATA_DBPATH} 20050550 1262693333
)

add_test(
    NAME ktoblzcheck_nl_invalid1
    COMMAND $<TARGET_FILE:ktoblzcheck-bin> --file=${BANKDATA_NL_DBPATH} ABNA 126269333345
)

add_test(
    NAME ktoblzcheck_ch_invalid1
    COMMAND $<TARGET_FILE:ktoblzcheck-bin> --file=${BANKDATA_CH_DBPATH} 00761 01162385295700
)

set_tests_properties(ktoblzcheck_de_invalid1 PROPERTIES WILL_FAIL 1)
set_tests_properties(ktoblzcheck_nl_invalid1 PROPERTIES WILL_FAIL 1)
set_tests_properties(ktoblzcheck_ch_invalid1 PROPERTIES WILL_FAIL 1)

#tests for AccountNumberCheck::BANK_NOT_KNOWN
add_test(
    NAME ktoblzcheck_de_invalid2
    COMMAND $<TARGET_FILE:ktoblzcheck-bin> --file=${BANKDATA_DBPATH} 2005055 1262693334
)

add_test(
    NAME ktoblzcheck_nl_invalid2
    COMMAND $<TARGET_FILE:ktoblzcheck-bin> --file=${BANKDATA_NL_DBPATH} ABNAA 0417164300
)

add_test(
    NAME ktoblzcheck_ch_invalid2
    COMMAND $<TARGET_FILE:ktoblzcheck-bin> --file=${BANKDATA_CH_DBPATH} 0076 011623852957
)

set_tests_properties(ktoblzcheck_de_invalid2 PROPERTIES WILL_FAIL 1)
set_tests_properties(ktoblzcheck_nl_invalid2 PROPERTIES WILL_FAIL 1)
set_tests_properties(ktoblzcheck_ch_invalid2 PROPERTIES WILL_FAIL 1)

#tests for AccountNumberCheck::UNKNOWN

add_test(
    NAME ktoblzcheck_de_invalid3
    COMMAND $<TARGET_FILE:ktoblzcheck-bin> --file=${BANKDATA_DBPATH} --method=100 2005055 1262693334
)

set_tests_properties(ktoblzcheck_de_invalid3 PROPERTIES WILL_FAIL 1)

if(ENABLE_METHOD_TESTS)
    add_method_tests(45
        PASS
            3545343232 4013410024 0994681254
            0000012340 1000199999 0100114240
            4890001112
    )
    add_method_tests(B1
        PASS
            # v1
            1434253150 2746315471
            # v2
            7414398260 8347251693
            # v3
            1501824 1501832 539290858
            7414398268 8347251699
        FAIL
            # v1
            1501824 1501832 539290858
            0123456789 2345678901 5678901234
            7414398260 7414398268 8347251693
            8347251699
            # v2
            1501824 1501832 539290858
            0123456789 2345678901 5678901234
            7414398268 8347251699
            # v3
            0123456789 2345678901 5678901234
    )
    add_method_tests(C2
        PASS
            # v1
            2394871426 4218461950 7352569148
            # v2
            5127485166 8738142564
            # v3
            0076543216 3456789012 9024675138
        FAIL
            # v1, v2
            5127485166 8738142564 0328705282
            9024675131 0076543216 3456789012
            9024675138 7352569145
            # v3
            0328705282 7352569145 9024675131
    )
    add_method_tests(E4
        PASS
           # v1
           1501836 9290702 539290858
           # v2
           1501824 1501832 9290701
        FAIL
           # v1
           1501824 1501832 9290701
           # v2
           12345007 87654005
    )
endif()

########### next target ###############

set(ctest_SRCS ctest.c)
add_executable(ctest ${ctest_SRCS})


########### next target ###############

set(benchmark_SRCS benchmark.cc)
add_executable(benchmark ${benchmark_SRCS})
target_link_libraries(benchmark ktoblzcheck ${SQLite3_LIBRARIES})

#Currently disabling; need to update benchmark code
add_test(
    NAME benchmark
    COMMAND ${TEST_WRAPPER} $<TARGET_FILE:benchmark> --file=${BANKDATA_DBPATH} 5
)

########### next target ###############

#
# TODO:  seems to be redundant (see lib)
#
set(ibanchk_SRCS ibanchk.cc)
add_executable(ibanchk ${ibanchk_SRCS})
target_link_libraries(ibanchk ktoblzcheck)

install(TARGETS ibanchk DESTINATION bin)

# not working yet because of different return code
#add_test(
#    NAME ibanchk_invalid
#    COMMAND $<TARGET_FILE:ibanchk> "FR1420041010050500013X02606"
#)

add_test(
    NAME ibanchk_de
    COMMAND ${TEST_WRAPPER} $<TARGET_FILE:ibanchk> "DE89 3704 0044 0532 0130 00"
)
set_tests_properties(ibanchk_de PROPERTIES
    ENVIRONMENT XDG_DATA_DIRS=${BANKDATA_PATH}
)

add_test(
    NAME ibanchk_fr
    COMMAND ${TEST_WRAPPER} $<TARGET_FILE:ibanchk> "fr14 2004 1010 0505 0001 3m02 606"
)
set_tests_properties(ibanchk_fr PROPERTIES
    ENVIRONMENT XDG_DATA_DIRS=${BANKDATA_PATH}
)

########### next target ###############

set(ktoblzupdate_SRCS ktoblzupdate.cc)
add_executable(ktoblzupdate ${ktoblzupdate_SRCS})
target_link_libraries(ktoblzupdate ktoblzcheck ${CURL_LIBRARIES})

install(TARGETS ktoblzupdate DESTINATION bin)

=== src/include/CMakeLists.txt ===

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ktoblzcheck.h.in ${CMAKE_CURRENT_BINARY_DIR}/ktoblzcheck.h)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ktoblzcheck_export.h ${CMAKE_CURRENT_BINARY_DIR}/ktoblzcheck_export.h COPYONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/ktoblzcheck.h iban.h ktoblzcheck_export.h DESTINATION include)

=== src/lib/CMakeLists.txt ===
--- 
+++ 
@@ -29,13 +29,6 @@
     set_target_properties(ktoblzcheck PROPERTIES VERSION ${LIBKTOBLZCHECK_EFFECTIVE}.${LIBKTOBLZCHECK_AGE}.${LIBKTOBLZCHECK_REVISION} SOVERSION ${LIBKTOBLZCHECK_EFFECTIVE})
 endif()
 
-add_dependencies(ktoblzcheck bankdata_de)
-add_dependencies(ktoblzcheck bankdata_db)
-add_dependencies(ktoblzcheck bankdata_nl_db)
-add_dependencies(ktoblzcheck bankdata_ch_db)
-add_dependencies(ktoblzcheck bankdata_test_db)
-add_dependencies(ktoblzcheck fetch_sepa)
-
 install(TARGETS ktoblzcheck ${INSTALL_TARGETS_DEFAULT_ARGS})
 
 ########### next target ###############
@@ -47,7 +40,7 @@
     NAME iban_check
     COMMAND ${TEST_WRAPPER} $<TARGET_FILE:iban_check>
 )
-set(env "BANKDATA_SRCPATH=${BANKDATA_SRCPATH}")
+set(env "XDG_DATA_DIRS=${BANKDATA_PATH}")
 set_tests_properties(iban_check PROPERTIES ENVIRONMENT "${env}")
 
 ########### next target ###############

=== src/python/CMakeLists.txt ===

install(FILES ktoblzcheck.py DESTINATION ${Python_SITEARCH})

if(Python_Interpreter_FOUND)
add_test(
    NAME test-python
    COMMAND ${Python_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/test_ktoblzcheck.py
)
set_tests_properties(test-python PROPERTIES
    ENVIRONMENT "LD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/lib;XDG_DATA_DIRS=${BANKDATA_PATH}"
)
endif()

=== debian/changelog ===
libktoblzcheck (1.59-1) experimental; urgency=medium

  * New upstream version 1.59.
  * Drop ENABLE_BANKDATA_DOWNLOAD_broken.patch (applied upstream and
    additionally code path got removed).
  * Drop bundled bankdata, as the build process doesn't need it anymore.
  * Drop Python build dependencies, as the build system doesn't need them
    anymore.
  * Disable running compile time tests as some of them (iban_check, ibanchk_de,
    ibanchk_fr, test-python) are known to be broken.
  * Rework autopkgtest.
  * Add fix_segfault_on_bankdata_parent_directory_not_existing.patch.
  * Package is compliant to Debian Policy 4.7.2 (no changes needed).
  * Move Git repository to Debian group in Salsa.

 -- Micha Lenk <micha@debian.org>  Sat, 23 Aug 2025 16:35:45 +0200

=== debian/control ===
--- 
+++ 
@@ -4,15 +4,12 @@
 Maintainer: Micha Lenk <micha@debian.org>
 Uploaders: Henning Glawe <glaweh@debian.org>
 Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
- dh-python,
  cmake,
  libcurl4-gnutls-dev,
  libsqlite3-dev,
- python3-all-dev,
- python3-openpyxl
-Standards-Version: 4.7.0
-Vcs-Browser: https://salsa.debian.org/aqbanking-team/pkg-ktoblzcheck
-Vcs-Git: https://salsa.debian.org/aqbanking-team/pkg-ktoblzcheck.git
+Standards-Version: 4.7.2
+Vcs-Browser: https://salsa.debian.org/debian/libktoblzcheck
+Vcs-Git: https://salsa.debian.org/debian/libktoblzcheck.git
 
 Package: libktoblzcheck1t64
 Provides: ${t64:Provides}

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
export DH_VERBOSE=1

%:
	dh $@

# Disable running tests as some of them (iban_check, ibanchk_de,
# ibanchk_fr, test-python) are known to be broken
override_dh_auto_test:

=== debian/tests/control ===
Test-Command: bats --print-output-on-failure --show-output-of-passing-tests --tap --recursive debian/tests
Depends: bats, bats-assert, ktoblzcheck
Restrictions: needs-internet

=== debian/watch ===
version=4
https://sf.net/ktoblzcheck/ \
  ktoblzcheck@ANY_VERSION@@ARCHIVE_EXT@ debian uupdate
